#################
# ALIB Versioning

message("[Versioning] Current version is ${PROJECT_VERSION}")

include(git)

if(BUILD_TYPE MATCHES "(Debug|Snapshot)")
	# sets ALIB_GIT_BRANCH
	# sets ALIB_GIT_DESCRIBE
	set_git_version()
endif()
if(BUILD_TYPE STREQUAL "Snapshot")
	# sets ALIB_SNAPSHOT_VERSION
	set_git_snapshot_version()
endif()

if(BUILD_TYPE STREQUAL "Debug")
	set(ALIB_VERSION_INFO "${PROJECT_VERSION} | Debug build @ ${ALIB_GIT_BRANCH} ${ALIB_GIT_DESCRIBE}" )
elseif(BUILD_TYPE STREQUAL "Release")
	set(ALIB_VERSION_INFO "${PROJECT_VERSION}")
elseif(BUILD_TYPE STREQUAL "Snapshot")
	set(ALIB_VERSION_INFO "${ALIB_SNAPSHOT_VERSION}")
endif()

configure_file (
	${CONFIGURE_HEADERS_SRC_DIR}/version.hpp.in
	${CONFIGURE_HEADERS_DST_DIR}/version.hpp
	)
install (
	FILES ${CONFIGURE_HEADERS_DST_DIR}/version.hpp
	DESTINATION include/algorithms-library/
	)
