/*
 * HistoryRegister.h
 *
 *  Created on: 20. 3. 2017
 *	  Author: Jan Travnicek
 */

#ifndef _HISTORY_REGISTER_H_
#define _HISTORY_REGISTER_H_

#include "ReadlinePromptHistory.h"

#include <lexer/Lexer.h>

class HistoryRegister {
	const cli::Lexer & m_lexer;
	bool m_allowHistory;

public:
	HistoryRegister ( const cli::Lexer & lexer, bool allowHistory ) : m_lexer ( lexer ), m_allowHistory ( allowHistory ) {
	}

	~HistoryRegister ( ) {
		if ( m_allowHistory ) {
			std::string line = m_lexer.getLine ( );
			ReadlinePromptHistory::addHistory ( ( std::string ) ext::trim ( line ) );
		}
	}
};

#endif /* _HISTORY_REGISTER_H_ */
