before () {
	apk add --no-cache git gnupg

	gpg_import
}

package () {
	set -e

	# just sign
	gpg --armor --detach-sig -o $ARCHIVE.sig $ARCHIVE

	set +e
}

deploy () {
	set -e
	MOUNTPOINTS="-v /srv/repository/sources:/repository -v$(pwd):/build -v/root/.gnupg/:/root/.gnupg/"
	DOCKER_IMAGE="alpine"
	DOCKER_CMD="docker run --rm $MOUNTPOINTS $DOCKER_IMAGE"

    docker login -u gitlab-ci-token -p $CI_JOB_TOKEN $CI_REGISTRY
	docker pull "$DOCKER_IMAGE:latest"

	$DOCKER_CMD sh -c "mv /build/*.tar.gz* /repository/"
	set +e
}
